require 'clamp'
require 'fileutils'

module Podpisy
  class CLI < Clamp::Command
    option ['-g', '--generate'], :flag, 'generate new signatures directory'
    option ['-a', '--areas'], :flag, 'convert postcode to aree in CSV'
    option ['-c', '--csv'], 'CSV', 'output to CSV file'
    option ['-t', '--tex'], 'TEX', 'output to TEX file'
    parameter 'file', 'csv file with signatures', attribute_name: :file

    def execute
      if generate?
        src = File.expand_path("../../../share/szablon", __FILE__)
        FileUtils.copy_entry src, file
        return
      end


      sigs = Signatures.new(file, areas: areas?)
      if csv
        open(csv, 'wb') do |out|
          sigs.to_csv out
        end
      end

      if tex
        open(tex, 'wb') do |out|
          sigs.to_tex out
        end
      end
    end
  end
end
